{% extends 'admin/adminbase.html.twig' %}
{% import "macros/datatable.html.twig" as dt %}
{% import "macros/genInputLevelPrice.html.twig" as lv %}
{% import "macros/genLoading.html.twig" as ld %}
{% block moreCss %}
    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/css/select2.min.css" rel="stylesheet"/>
{% endblock %}
{% block body %}
    <div class="card-genossys">
        <h5>Wilayah Layanan</h5>
        <div class="pb-5">
            <div class="float-right">
                <a class="btn btn-primary" onclick="" id="addData">Tambah Harga Offline</a>
            </div>
        </div>
        {{ dt.datatable }}
    </div>

    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <form id="loginForm" method="post" onsubmit="return cekData()">
                    <input id="id" name="id" hidden>
                    <input id="action" name="action" hidden>
                    <input id="procinceName" name="procinceName" hidden>
                    <input id="cityName" name="cityName" hidden>
                    <input id="districName" name="districName" hidden>
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Tambah Pricing</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="provinsi">Privinsi</label>
                            <select id="provinsi" class="form-control" onchange="selectProvince()" style="width: 100%">
                                <option value="">Pilih Provinsi</option>
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="kota">Kota</label>
                            <select id="kota" class="form-control" name="city" onchange="selectCity()" style="width: 100%">
                                <option value="">Pilih Kota</option>
                            </select>
                        </div>
                        {#                        <div class="form-group">#}
                        {#                            <label for="wilayah">Wilayah</label>#}
                        {#                            <select id="wilayah" class="form-control" style="width: 100%">#}
                        {#                                <option value="" >Pilih Wilayah</option>#}
                        {#                            </select>#}
                        {#                        </div>#}
                        <div class="row">
                            <div class="col-6">
                                <label>Basic</label>
                                {{ lv.input_level_price() }}
                            </div>
                            <div class="col-6">
                                <label>Profesional</label>
                                {{ lv.input_level_price('profesional') }}

                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary " data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Simpan</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    {{ ld.modal_loading() }}
{% endblock %}

{% block javascripts %}
    <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/js/select2.min.js"></script>

    <script src="{{ asset('etc/js/currency.js') }}"></script>

    <script>
        function cekData() {
            if ($('#provinsi').val() === '' || $('#kota').val() === '') {
                alertify.alert('Warning', 'Silahkan masukkan data dengan benar !', function(){ alertify.success('Ok'); });
            }else {
                alertify.confirm('Info', 'Apakah anda yakin untuk menyimpan data ?', function () {
                    $('#loading').modal();
                    document.getElementById('loginForm').submit();
                }, function () {
                }).set('labels', {ok:'Ya', cancel:'Tidak'}).set({transition: 'fade'});
            }
            return false;


        }

        $(document).ready(function () {
            currencyClass('rupiah');
            $('#wilayah').select2();
            $('#kota').select2();
            getProvince();
            $('#provinsi').select2();
        });

        $(document).on("click", 'a#addData', function () {
            // $('#kota').empty();
            // $('#provinsi').empty();
            clearSelect();
            $(".checktext").prop("checked", false);
            // $(".rupiah").attr('disabled', '');
            $(".rupiah").val('');
            $('.idPricing').val('');

            $('#action').val('add');
            $('#modal').modal();
        });

        $(document).on("click", 'a#editData', function () {
            // $(".checktext").prop("checked", false);
            // $(".rupiah").attr('disabled', '');
            $('#provinsi').val($(this).data('provinceid')).trigger("change").select2();
            selectProvince($(this).data('cityid'));
            selectCity($(this).data('cityid'));

            $('#action').val('edit');
            $('#modal').modal();
        });

        function clearSelect() {
            getProvince();
            $('#provinsi').val('').trigger("change").select2();
            selectProvince();
        }

        async function getProvince() {
            $('#provinsi').empty();
            await $.get('{{ path('get-province') }}', function (data) {
                var select = $('#provinsi');
                select.append('<option value="">Pilih Provinsi</option>')
                $.each(data['payload'], function (key, value) {
                    select.append('<option value="' + value['id'] + '">' + value['nama'] + '</option>')
                });

            })
        }

        // $(document).on("change", 'select#provinsi', function (ev) {
        //     $('#kota').empty();
        //     console.log($(this).val());
        //     $('#procinceName').val(ev.currentTarget.options[ev.currentTarget.selectedIndex].text);
        //     $.get("/admin/get-city?province=" + $(this).val(), function (data) {
        //         var select = $('#kota');
        //         $.each(data['payload'], function (key, value) {
        //             select.append('<option value="' + value['id'] + '">' + value['nama'] + '</option>')
        //         });
        //     })
        // });

        function selectProvince(a) {
            $('#kota').empty();
            $('#kota').append('<option value="" selected >Pilih Kota</option>');
            $.get("/admin/get-city?province=" + $('#provinsi').val(), function (data) {
                var select = $('#kota');
                $.each(data['payload'], function (key, value) {
                    if (a && a === value['id']) {
                        select.append('<option value="' + value['id'] + '" selected >' + value['nama'] + '</option>')
                    } else {
                        select.append('<option value="' + value['id'] + '" >' + value['nama'] + '</option>')
                    }

                });
            })
        }

        function selectCity(a) {
            var id = a ?? $('#kota').val();
            id = id === '' ? 0 : id;
            console.log(id);

            // $('.checktext').prop("checked", false);
            $('.rupiah').val('');
            $('.idPricing').val('');
            $('#action').val('add');
            $.get("/admin/get-price?city=" + id, function (data) {
                $.each(data['payload'], function (key, value) {
                    $('#action').val('edit');
                    // select.append('<option value="' + value['id'] + '">' + value['nama'] + '</option>')
                    var grade = value['grade'] === 'BASIC' ? 'basic' : 'profesional';
                    var price = parseInt(value['price']).toLocaleString();
                    // $('#' + grade + '' + value['level_name']).prop("checked", true);
                    // $('#text' + grade + '' + value['level_name']).removeAttr('disabled');
                    $('#text' + grade + '' + value['level_name']).val(price);
                    $('#check' + grade + '' + value['level_name']).val(value['level_id']);
                    // $('#check' + grade + '' + value['level_name']).removeAttr('disabled');
                    // $('#id' + grade + '' + value['level_name']).removeAttr('disabled');
                    $('#id' + grade + '' + value['level_name']).val(value['id']);

                });
            })
        }

        $(document).on("click", "a#deletePricingData", function (ev) {
            var cityid = $(this).data('city');

            alertify.confirm('Warning', 'Apakah anda yakin untuk menghapus data pricing ' + $(this).data('cityname') + ' ?', function () {

                    $.ajax({
                        url: '{{ path('delete-pricing-wilayah') }}',
                        method: 'POST',
                        data: {
                            'cityid': cityid,
                        },
                        success: function (data) {
                            $('#tableData').DataTable().ajax.reload();
                            console.log(data);
                            alertify.notify(data['status'], data['label'], 5, function () {
                                console.log('dismissed');
                            });
                        }
                    });

                }
                , function () {
                    // showToast('Data tidak dihapus', 'warning');
                    alertify.notify('Data tidak dihapus', 'danger', 5, function () {
                        console.log('dismissed');
                    });

                }
            ).set({transition: 'fade'});
        });

        // $(document).on("change", 'select#kota', function (ev) {
        //     $('#wilayah').empty();
        //     $('#cityName').val(ev.currentTarget.options[ev.currentTarget.selectedIndex].text);
        //     $('.checktext').prop("checked", false);
        //     $('.rupiah').val('').attr('disabled','');
        //     $.get("/admin/get-price?city=" + $(this).val(), function (data) {
        //         $.each(data['payload'], function (key, value) {
        //             // select.append('<option value="' + value['id'] + '">' + value['nama'] + '</option>')
        //             var grade = value['grade'] === 'BASIC' ? 'basic' : 'profesional';
        //             var price = parseInt(value['price']).toLocaleString();
        //             $('#'+grade+''+value['level_name']).prop("checked", true);
        //             $('#text'+grade+''+value['level_name']).removeAttr('disabled');
        //             $('#text'+grade+''+value['level_name']).val(price);
        //             console.log(grade);
        //             console.log(value);
        //         });
        //     })
        // });
        //
        // $(document).on("change", 'select#wilayah', function (ev) {
        //     $('#districName').val(ev.currentTarget.options[ev.currentTarget.selectedIndex].text);
        // });

        function modalWilayah() {
            <!-- the form to be viewed as dialog-->

            alertify.genericDialog || alertify.dialog('genericDialog', function () {
                return {
                    main: function (content) {
                        this.setContent(content);
                    },
                    build: function () {
                        var errorHeader = 'Form Wilayah';
                        this.setHeader(errorHeader);
                    },
                    setup: function () {
                        return {
                            focus: {
                                element: function () {
                                    return this.elements.body.querySelector(this.get('selector'));
                                },
                                select: true
                            },

                            options: {
                                basic: true,
                                maximizable: false,
                                resizable: false,
                                padding: false
                            }
                        };
                    },
                    settings: {
                        selector: undefined
                    }
                };
            });
//force focusing password box
            alertify.genericDialog(' <div class="p-3">\n' +
                '        <form id="loginForm">\n' +
                '            <fieldset>\n' +
                '                <div class="form-group">\n' +
                '                    <label for="districName">Wilayah</label>\n' +
                '                    <input type="text" class="form-control" id="districName" placeholder="Serengan">\n' +
                '                </div>\n' +
                '                <div class="form-group">\n' +
                '                    <label for="cityName">Kota</label>\n' +
                '                    <input type="text" class="form-control" id="cityName" placeholder="Surakarta">\n' +
                '                </div>\n' +
                '                <div class="form-group">\n' +
                '                    <label for="provinceName">Provinsi</label>\n' +
                '                    <input type="text" class="form-control" id="provinceName" placeholder="Jawa Tengah">\n' +
                '                </div>\n' +
                '                <a type="submit" onclick="test()" class="btn btn-primary" value="Save">simpan</a>\n' +
                '            </fieldset>\n' +
                '        </form>\n' +
                '    </div>').set('selector', 'input[type="password"]');
        }

        function test() {
            console.log($('#districName').val());
        }
    </script>

    {{ dt.datatableJS(class, space, tableAction, tableFields,where,groupByKota,'yes','yes') }}
    {{ lv.input_level_price_js() }}
    {{ lv.input_level_price_js('profesional') }}

{% endblock %}